#include <vtkCellData.h>
#include <vtkIntArray.h>
#include <vtkNew.h>
#include <vtkPolyData.h>
#include <vtkPolyDataReader.h>
#include <vtkPolyDataWriter.h>

int main()
{
	vtkNew<vtkPolyDataReader> reader;
	reader->SetFileName("sphere.vtk");
	reader->Update();

	vtkNew<vtkPolyData> tmp;
	tmp->DeepCopy(reader->GetOutput());
	tmp->BuildLinks();
	vtkIntArray* intArray = vtkIntArray::SafeDownCast(tmp->GetCellData()->GetArray("Result"));

	const int ncells = tmp->GetNumberOfCells();
	for(int cellId=0; cellId < ncells; ++cellId)
	{
		if(intArray->GetValue(cellId) != 0)
		{
			tmp->DeleteCell(cellId);
		}
	}
	tmp->RemoveDeletedCells();

	vtkNew<vtkPolyDataWriter> writer;
	writer->SetFileName("output.vtk");
	writer->SetInputData(tmp.GetPointer());
	writer->Write();
}
